library isyumi;

import "httpserver.dart";
import "www/isyumi_transfer.dart";
import "where_then.dart";

import "dart:async";

part "ui.dart";

void onConnection(String host,void f(Client client)){
  
  start_server().listen((connection){
    UrlStruct us = connection.it.url;
    us.onData.listen((_){
      us.cancel();
      Client c = new Client(connection.it,f);
    });
  });
  
}

typedef bool State();

class Client extends FirstWhere{
  
  final Document document;
  final Cookies cookies;
  final IsyumiTransfer _it;
  Uri get url => _url; 
  Uri _url;
  final StreamController _onChangeStreamController;
  
  factory Client(IsyumiTransfer it,void f(Client client)){
    var url = getURL(it);
    var el = new _EditListener(it);
    var document = new Document._(el);
    var cookies = new Cookies();
    var current_where_stream = new StreamController<List<int>>();
    var on_change_stream_controller = new StreamController();
    var client = new Client._(it,cookies,url,document,f,current_where_stream,on_change_stream_controller);
    current_where_stream.stream.listen(document._current_where_id);
    return client;
  }
  
  Client._(
      this._it,
      this.cookies,
      this._url,
      this.document,
      void f(Client client),
      StreamController<List<int>> current_where_stream,
      StreamController onChangeStreamController):
        super(current_where_stream,onChangeStreamController.stream,f),
        _onChangeStreamController = onChangeStreamController{
        _it.url.onData.listen(onURL);
      }
  
  void onURL(e){
    _url = getURL(_it);
    _it.reset.send();
    _onChangeStreamController.add(null);
    
  }
  
  static Uri getURL(IsyumiTransfer it) =>  Uri.parse(it.url.url.value);
  
}

class Cookies{
  
}
